! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Utility Data Module File
! 
! Generated by KPP-2.2.1_rs5 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : messy_mecca_kpp_Monitor.f90
! Time                 : Mon Dec 20 17:34:19 2010
! Working directory    : /home/sander/e2/messy_d2.40f_rs/messy/mbm/caaba/mecca
! Equation file        : messy_mecca_kpp.kpp
! Output root filename : messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE messy_mecca_kpp_Monitor


  CHARACTER(LEN=32), PARAMETER, DIMENSION(33) :: SPC_NAMES = (/ &
     'N2O                             ','NH3                             ','CH4                             ', &
     'HCOOH                           ','O3P                             ','N2O5                            ', &
     'H                               ','H2O2                            ','H2                              ', &
     'CH3OH                           ','CO                              ','O1D                             ', &
     'NH2OH                           ','NHOH                            ','HNO4                            ', &
     'CH3OOH                          ','HONO                            ','HNO3                            ', &
     'H2O                             ','NH2O                            ','HNO                             ', &
     'NH2                             ','HCHO                            ','CH3O2                           ', &
     'NO3                             ','O3                              ','NO                              ', &
     'OH                              ','HO2                             ','NO2                             ', &
     'O2                              ','N2                              ','CO2                             ' /)

  INTEGER, DIMENSION(1) :: LOOKAT
  INTEGER, DIMENSION(1) :: MONITOR
  CHARACTER(LEN=32), DIMENSION(1) :: SMASS
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_0 = (/ &
     '   O1D + O2 --> O3P + O2                                                                            ', &
     '   O3P + O2 --> O3                                                                                  ', &
     '     H + O2 --> HO2                                                                                 ', &
     '    O3 + OH --> HO2 + O2                                                                            ', &
     '    H2 + OH --> H + H2O                                                                             ', &
     '   O3 + HO2 --> OH + 2 O2                                                                           ', &
     '   OH + HO2 --> H2O + O2                                                                            ', &
     '      2 HO2 --> H2O2 + O2                                                                           ', &
     '  O1D + H2O --> 2 OH                                                                                ', &
     '  H2O2 + OH --> H2O + HO2                                                                           ', &
     '   O1D + N2 --> O3P + N2                                                                            ', &
     '    O3 + NO --> NO2 + O2                                                                            ', &
     '   O3 + NO2 --> NO3 + O2                                                                            ', &
     '   NO3 + NO --> 2 NO2                                                                               ', &
     '  NO3 + NO2 --> N2O5                                                                                ', &
     '       N2O5 --> NO3 + NO2                                                                           ', &
     '    NO + OH --> HONO                                                                                ', &
     '   NO + HO2 --> OH + NO2                                                                            ', &
     '   OH + NO2 --> HNO3                                                                                ', &
     '  HO2 + NO2 --> HNO4                                                                                ', &
     '  NO3 + HO2 --> OH + NO2 + O2                                                                       ', &
     '  HONO + OH --> H2O + NO2                                                                           ', &
     '  HNO3 + OH --> H2O + NO3                                                                           ', &
     '       HNO4 --> HO2 + NO2                                                                           ', &
     '  HNO4 + OH --> H2O + NO2                                                                           ', &
     '   NH3 + OH --> H2O + NH2                                                                           ', &
     '   NH2 + O3 --> NH2O + O2                                                                           ', &
     '  NH2 + HO2 --> NH2O + OH                                                                           ', &
     '  NH2 + HO2 --> H2O + HNO                                                                           ', &
     '   NH2 + NO --> OH + HO2 + N2                                                                       ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_1 = (/ &
     '   NH2 + NO --> H2O + N2                                                                            ', &
     '  NH2 + NO2 --> N2O + H2O                                                                           ', &
     '  NH2 + NO2 --> NH2O + NO                                                                           ', &
     '  NH2O + O3 --> NH2 + O2                                                                            ', &
     '       NH2O --> NHOH                                                                                ', &
     '   HNO + OH --> H2O + NO                                                                            ', &
     ' NHOH + HNO --> NH2OH + NO                                                                          ', &
     '  HNO + NO2 --> HONO + NO                                                                           ', &
     '  NHOH + OH --> H2O + HNO                                                                           ', &
     ' NH2OH + OH --> NHOH + H2O                                                                          ', &
     '   HNO + O2 --> NO + HO2                                                                            ', &
     '   CH4 + OH --> H2O + CH3O2                                                                         ', &
     ' CH3OH + OH --> HCHO + HO2                                                                          ', &
     'CH3O2 + HO2 --> CH3OOH + O2                                                                         ', &
     ' CH3O2 + NO --> HCHO + HO2 + NO2                                                                    ', &
     'CH3O2 + NO3 --> HCHO + HO2 + NO2                                                                    ', &
     '      CH3O2 --> HCHO + HO2                                                                          ', &
     '      CH3O2 --> 0.5 CH3OH + 0.5 HCHO + 0.5 O2                                                       ', &
     'CH3OOH + OH --> H2O + 0.3 HCHO + 0.7 CH3O2 + 0.3 OH                                                 ', &
     '  HCHO + OH --> CO + H2O + HO2                                                                      ', &
     ' HCHO + NO3 --> CO + HNO3 + HO2                                                                     ', &
     '    CO + OH --> H + CO2                                                                             ', &
     ' HCOOH + OH --> H2O + HO2 + CO2                                                                     ', &
     '         O2 --> 2 O3P                                                                               ', &
     '         O3 --> O1D                                                                                 ', &
     '         O3 --> O3P                                                                                 ', &
     '       H2O2 --> 2 OH                                                                                ', &
     '        NO2 --> O3P + NO                                                                            ', &
     '        NO3 --> O3P + NO2                                                                           ', &
     '        NO3 --> NO                                                                                  ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(7) :: EQN_NAMES_2 = (/ &
     '       N2O5 --> NO3 + NO2                                                                           ', &
     '       HONO --> NO + OH                                                                             ', &
     '       HNO3 --> OH + NO2                                                                            ', &
     '       HNO4 --> 0.333 NO3 + 0.333 OH + 0.667 HO2 + 0.667 NO2                                        ', &
     '     CH3OOH --> HCHO + OH + HO2                                                                     ', &
     '       HCHO --> H2 + CO                                                                             ', &
     '       HCHO --> H + CO + HO2                                                                        ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(67) :: EQN_NAMES = (/&
    EQN_NAMES_0, EQN_NAMES_1, EQN_NAMES_2 /)

  CHARACTER(LEN=32), PARAMETER, DIMENSION(67) :: EQN_TAGS = (/ &
     'G1000                           ','G1001                           ','G2100                           ', &
     'G2104                           ','G2105                           ','G2107                           ', &
     'G2109                           ','G2110                           ','G2111                           ', &
     'G2112                           ','G3101                           ','G3103                           ', &
     'G3106                           ','G3108                           ','G3109                           ', &
     'G3110                           ','G3200                           ','G3201                           ', &
     'G3202                           ','G3203                           ','G3204                           ', &
     'G3205                           ','G3206                           ','G3207                           ', &
     'G3208                           ','G3209                           ','G3210                           ', &
     'G3211                           ','G3212                           ','G3213                           ', &
     'G3214                           ','G3215                           ','G3216                           ', &
     'G3217                           ','G3218                           ','G3219                           ', &
     'G3220                           ','G3221                           ','G3222                           ', &
     'G3223                           ','G3224                           ','G4101                           ', &
     'G4102                           ','G4103                           ','G4104                           ', &
     'G4105                           ','G4106a                          ','G4106b                          ', &
     'G4107                           ','G4108                           ','G4109                           ', &
     'G4110                           ','G4111                           ','J1000                           ', &
     'J1001a                          ','J1001b                          ','J2101                           ', &
     'J3101                           ','J3103a                          ','J3103b                          ', &
     'J3104a                          ','J3200                           ','J3201                           ', &
     'J3202                           ','J4100                           ','J4101a                          ', &
     'J4101b                          ' /)

! INLINED global variables

! End INLINED global variables


END MODULE messy_mecca_kpp_Monitor
